#ifndef _IHEX_FILE_H_
#define _IHEX_FILE_H_

#include <inttypes.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>

#include "intelhex.h"

// Temp filename template
#define TMPLATE         "tmpXXXXXX"

// Define a default buffer length, if not defined with -D
#ifndef BUFLEN
#define BUFLEN          32
#endif

// Define a (hex) line length long enough to contain BUFLEN
#define LINELEN         IHEX_LINEMIN + (BUFLEN * 2)

// Verify BUFLEN is within acceptable range
#if ( (BUFLEN < 1) || (BUFLEN > 255) )
#error BUFLEN must be defined to a value between 1 and 255
#endif

#endif // _IHEX_FILE_H_