#ifndef _UUENCODE_H_
#define _UUENCODE_H_

#include <stdint.h>
#include <stddef.h>
#include <string.h>


/* - Constants ------------------------------------------------------------ */

// Buffer lengths
#define UU_DATAMAX                  45      // One line's worth of input data
#define UU_LINEMAX                  62      // Max length of an encoded line

// Encoded line format:
// <Len><Data><NULL> == 1 + ((DataLen / 3) * 4) + 1  (DataLen must be % 3)


/* - Function Prototypes -------------------------------------------------- */

void     uu_encode_line (const char *in, char *out, uint8_t datalen, uint32_t *cksum);
uint8_t  uu_decode_line (const char *in, char *out, uint32_t *cksum);
void     uu_encode      (const char *in, char *out);
void     uu_decode      (const char *in, char *out);
uint32_t uu_checksum    (const char *in, uint16_t len);

#endif // _UUENCODE_H_